<script setup lang="ts">
    import { computed } from "vue";
    import useAuthStore from "./../stores/auth";
    import useNavigationStore, { defaultTabBase } from "./../stores/navigation";
    import ModifyInstructorsList from "./RegisterCards/ModifyInstructorsList.vue";
    import ModifyParticipantsList from "./RegisterCards/ModifyParticipantsList.vue";
    import { useDeps } from "./event-and-zirkel";
    import { pushToClipboard } from "../functions/clipboard";
    import VDatePicker from "./Wrappers/DatePicker.vue";
    import StatisticsChart from "./Wrappers/StatisticsChart.vue";
    import { DynamicRoutePaths } from "../plugins/router";
    import { useRouter } from "vue-router";

    const { event, zirkel, logicalEventId, isVBW, isInfo } = useDeps();

    const navigationStore = useNavigationStore();
    const authStore = useAuthStore();
    const router = useRouter();

    navigationStore.$subscribe((_mutation, _state) => {
        router.push({ name: DynamicRoutePaths.EventAndZirkelDetails }); // TODO move this out possibly
    });

    const statistics = computed(() => {
        const listTypes = ["ct", "wl"];
        const classYears = ["5", "6", "7", "8", "9", "10", "11", "12", "all"];
        let stats = JSON.parse(event.value.statistics ?? "{}") as { [key: string]: number };
        listTypes.forEach((listType) => {
            classYears.forEach((classYear) => {
                const keys = {
                    all: `${listType}_all_${classYear}`,
                    male: `${listType}_male_${classYear}`,
                    female: `${listType}_female_${classYear}`,
                    others: `${listType}_others_${classYear}`,
                };

                const all = stats[keys.all] ?? 0;
                const male = stats[keys.male] ?? 0;
                const female = stats[keys.female] ?? 0;
                stats[keys.others] = all - male - female;
            });
        });
        return stats;
    });
</script>

<template>
    <div class="pa-3">
        <h2 class="text-center">Event + Zirkel Details</h2>

        <v-card variant="tonal" class="my-2">
            <template v-slot:title>
                <span v-if="zirkel && zirkel != null && zirkel != undefined"> Zirkel: {{ zirkel.name }} (</span>
                <span v-if="event && event != null && event != undefined">Event: {{ event.name }}, {{ event.year }}</span>
                <span v-if="zirkel && zirkel != null && zirkel != undefined">)</span>
            </template>
            <template v-slot:text
                ><v-tabs v-model="navigationStore.eventZirkelViewTab">
                    <v-tab :value="defaultTabBase"> Stammdaten </v-tab>
                    <v-tab value="instructors"> Zirkelleiter </v-tab>
                    <template v-if="!isVBW">
                        <v-tab value="orga"> Teilnehmer-Orga </v-tab>
                        <v-tab v-if="authStore.hasReadParticipant" value="left"> Teilnehmer-Abgemeldet </v-tab>
                        <v-tab v-if="authStore.hasReadParticipant" value="waiting_list"> Warteliste </v-tab>
                        <v-tab v-if="authStore.hasReadParticipant" value="signed_off"> Nichtteilnahme </v-tab>
                    </template>
                </v-tabs>

                <v-card-text>
                    <v-window v-model="navigationStore.eventZirkelViewTab">
                        <v-window-item :value="defaultTabBase">
                            <v-row>
                                <div class="v-col-lg-6 v-col-12">
                                    <h2 class="mb-5">
                                        Stammdaten des
                                        <span v-if="zirkel && zirkel != null && zirkel != undefined">
                                            Zirkel {{ zirkel.name }}
                                        </span>
                                        <span v-else>
                                            Event
                                            <span v-if="event && event != null && event != undefined">
                                                {{ event.name }}, {{ event.year }}
                                            </span>
                                        </span>
                                    </h2>
                                    <v-row class="v-col-12 justify-center" dense>
                                        <template v-if="zirkel && zirkel != null && zirkel != undefined">
                                            <v-text-field
                                                density="comfortable"
                                                v-model="zirkel.id"
                                                label="UUID"
                                                class="v-col-12"
                                                append-inner-icon="mdi-content-copy"
                                                readonly
                                                @click:append-inner="pushToClipboard(zirkel.id, 'ID kopiert')"
                                            ></v-text-field>
                                            <v-text-field
                                                density="comfortable"
                                                v-model="zirkel.name"
                                                label="Name"
                                                class="v-col-12"
                                                readonly
                                            ></v-text-field>
                                            <v-text-field
                                                density="comfortable"
                                                v-model="zirkel.room"
                                                label="Raum"
                                                class="v-col-12"
                                                readonly
                                            ></v-text-field>
                                        </template>
                                        <template v-else>
                                            <template v-if="event && event != null && event != undefined">
                                                <v-text-field
                                                    density="comfortable"
                                                    v-model="event.id"
                                                    label="UUID"
                                                    class="v-col-12"
                                                    append-inner-icon="mdi-content-copy"
                                                    readonly
                                                    @click:append-inner="pushToClipboard(event.id, 'ID kopiert')"
                                                ></v-text-field>
                                                <v-text-field
                                                    density="comfortable"
                                                    v-model="event.name"
                                                    label="Name"
                                                    class="v-col-12"
                                                    readonly
                                                ></v-text-field>
                                                <v-text-field
                                                    density="comfortable"
                                                    v-model="event.year"
                                                    label="Jahr"
                                                    class="v-col-6"
                                                    readonly
                                                ></v-text-field>
                                                <v-text-field
                                                    density="comfortable"
                                                    v-model="event.type"
                                                    label="Typ"
                                                    class="v-col-6"
                                                    readonly
                                                ></v-text-field>
                                                <v-text-field
                                                    density="comfortable"
                                                    v-model="event.defaultFee"
                                                    label="Kosten"
                                                    class="v-col-6"
                                                    readonly
                                                ></v-text-field>
                                                <v-select
                                                    readonly
                                                    v-model="event.giveInstructorsFullReadAccess"
                                                    density="comfortable"
                                                    class="v-col-6"
                                                    label="Eventweiter Zirkelleiter Lesezugriff"
                                                    :items="[
                                                        { value: true, title: 'Ja' },
                                                        { value: false, title: 'Nein' },
                                                    ]"
                                                ></v-select>
                                                <v-date-picker
                                                    v-model="event.startDate"
                                                    density="comfortable"
                                                    label="Startdatum"
                                                    class="v-col-md-6"
                                                    readonly
                                                ></v-date-picker>
                                                <v-date-picker
                                                    v-model="event.endDate"
                                                    density="comfortable"
                                                    label="Enddatum"
                                                    class="v-col-md-6"
                                                    readonly
                                                ></v-date-picker>
                                                <StatisticsChart v-if="!(isVBW || isInfo)" :statistics="statistics" />
                                            </template>
                                        </template>
                                    </v-row>
                                </div>
                                <div class="v-col-lg-6 v-col-12" v-if="event && event != null && event != undefined">
                                    <h2 class="mb-5">
                                        Weitere Zirkel im Event
                                        <span> {{ event.name }}, {{ event.year }} </span>
                                    </h2>
                                    <v-table
                                        density="compact"
                                        @touchstart.native.stop
                                        @touchmove.native.stop
                                        @touchend.native.stop
                                    >
                                        <tbody>
                                            <tr>
                                                <td>{{ event.name }}, {{ event.year }}</td>
                                                <td>
                                                    <v-btn size="small" @click="navigationStore.eventId = event.id">
                                                        <template v-slot:prepend>
                                                            <span class="material-symbols-outlined"> search </span></template
                                                        >
                                                        Veranstaltung anzeigen
                                                    </v-btn>
                                                </td>
                                            </tr>
                                            <tr>
                                                <td>&nbsp;</td>
                                                <td></td>
                                            </tr>
                                            <tr v-for="zirkel in event.zirkel ?? []">
                                                <td>{{ zirkel.name }}</td>
                                                <td>
                                                    <v-btn size="small" @click="navigationStore.zirkelId = zirkel.id">
                                                        <template v-slot:prepend>
                                                            <span class="material-symbols-outlined"> search </span></template
                                                        >
                                                        Zirkel anzeigen
                                                    </v-btn>
                                                </td>
                                            </tr>
                                        </tbody>
                                    </v-table>
                                </div>
                            </v-row>
                        </v-window-item>
                        <v-window-item value="instructors">
                            <h2 class="mb-5">
                                Zirkelleiter Tabelle des
                                <span v-if="zirkel && zirkel != null && zirkel != undefined"> Zirkel {{ zirkel.name }} </span>
                                <span v-else>
                                    Event
                                    <span v-if="event && event != null && event != undefined">
                                        {{ event.name }}, {{ event.year }}
                                    </span>
                                </span>
                            </h2>
                            <ModifyInstructorsList
                                event-or-zirkel="event"
                                :id="logicalEventId"
                                :event-id="logicalEventId"
                                v-if="
                                    event &&
                                    event != null &&
                                    event != undefined &&
                                    !(zirkel && zirkel != null && zirkel != undefined)
                                "
                                :event-type="event.type"
                            ></ModifyInstructorsList>
                            <ModifyInstructorsList
                                event-or-zirkel="zirkel"
                                :id="zirkel.id"
                                :event-id="logicalEventId"
                                v-if="
                                    event &&
                                    event != null &&
                                    event != undefined &&
                                    zirkel &&
                                    zirkel != null &&
                                    zirkel != undefined
                                "
                                :event-type="event.type"
                            ></ModifyInstructorsList>
                        </v-window-item>
                        <v-window-item value="orga">
                            <h2 class="mb-5">
                                Orga Tabelle des
                                <span v-if="zirkel && zirkel != null && zirkel != undefined"> Zirkel {{ zirkel.name }} </span>
                                <span v-else>
                                    Event
                                    <span v-if="event && event != null && event != undefined">
                                        {{ event.name }}, {{ event.year }}
                                    </span>
                                </span>
                            </h2>
                            <ModifyParticipantsList
                                type="orga"
                                event-or-zirkel="event"
                                :id="logicalEventId"
                                :event-id="logicalEventId"
                                v-if="
                                    event &&
                                    event != null &&
                                    event != undefined &&
                                    !(zirkel && zirkel != null && zirkel != undefined)
                                "
                                :event-type="event.type"
                            ></ModifyParticipantsList>
                            <ModifyParticipantsList
                                type="orga"
                                event-or-zirkel="zirkel"
                                :id="zirkel.id"
                                :event-id="logicalEventId"
                                v-if="
                                    event &&
                                    event != null &&
                                    event != undefined &&
                                    zirkel &&
                                    zirkel != null &&
                                    zirkel != undefined
                                "
                                :event-type="event.type"
                            ></ModifyParticipantsList>
                        </v-window-item>
                        <v-window-item value="left" v-if="authStore.hasReadParticipant">
                            <h2 class="mb-5">
                                Tabelle der Abgemeldeten Teilnehmer (nach Veranstaltungsstart) des
                                <span v-if="zirkel && zirkel != null && zirkel != undefined"> Zirkel {{ zirkel.name }} </span>
                                <span v-else>
                                    Event
                                    <span v-if="event && event != null && event != undefined">
                                        {{ event.name }}, {{ event.year }}
                                    </span>
                                </span>
                            </h2>
                            <ModifyParticipantsList
                                type="left"
                                event-or-zirkel="event"
                                :id="logicalEventId"
                                :event-id="logicalEventId"
                                v-if="
                                    event &&
                                    event != null &&
                                    event != undefined &&
                                    !(zirkel && zirkel != null && zirkel != undefined)
                                "
                                :event-type="event.type"
                            ></ModifyParticipantsList>
                            <ModifyParticipantsList
                                type="left"
                                event-or-zirkel="zirkel"
                                :id="zirkel.id"
                                :event-id="logicalEventId"
                                v-if="
                                    event &&
                                    event != null &&
                                    event != undefined &&
                                    zirkel &&
                                    zirkel != null &&
                                    zirkel != undefined
                                "
                                :event-type="event.type"
                            ></ModifyParticipantsList>
                        </v-window-item>
                        <v-window-item value="waiting_list" v-if="authStore.hasReadParticipant">
                            <h2 class="mb-5">
                                Warteliste Tabelle des
                                <span v-if="zirkel && zirkel != null && zirkel != undefined"> Zirkel {{ zirkel.name }} </span>
                                <span v-else>
                                    Event
                                    <span v-if="event && event != null && event != undefined">
                                        {{ event.name }}, {{ event.year }}
                                    </span>
                                </span>
                            </h2>
                            <v-row v-if="zirkel && zirkel != null && zirkel != undefined" no-gutters>
                                <div class="v-col-12">
                                    <p>
                                        Wartelistenansicht für einen Zirkel macht keinen Sinn und sollte logischerweise immer leer
                                        sein.
                                    </p>
                                    <p>Daher wird hier nichts angezeigt.</p>
                                    <v-btn
                                        size="small"
                                        @click="navigationStore.eventId = event.id"
                                        v-if="event && event != null && event != undefined"
                                        class="mt-3"
                                    >
                                        <template v-slot:prepend>
                                            <span class="material-symbols-outlined"> search </span></template
                                        >
                                        Wechsel zum Event
                                    </v-btn>
                                </div>
                            </v-row>
                            <ModifyParticipantsList
                                type="waiting"
                                event-or-zirkel="event"
                                :id="logicalEventId"
                                :event-id="logicalEventId"
                                v-if="
                                    event &&
                                    event != null &&
                                    event != undefined &&
                                    !(zirkel && zirkel != null && zirkel != undefined)
                                "
                                :event-type="event.type"
                            ></ModifyParticipantsList>
                        </v-window-item>
                        <v-window-item value="signed_off" v-if="authStore.hasReadParticipant">
                            <h2 class="mb-5">
                                Nichtteilnahme Tabelle (Abbruch des Anmeldungsprozesses vor Veranstaltungsstart) des
                                <span v-if="zirkel && zirkel != null && zirkel != undefined"> Zirkel {{ zirkel.name }} </span>
                                <span v-else>
                                    Event
                                    <span v-if="event && event != null && event != undefined">
                                        {{ event.name }}, {{ event.year }}
                                    </span>
                                </span>
                            </h2>
                            <v-row v-if="zirkel && zirkel != null && zirkel != undefined" no-gutters>
                                <div class="v-col-12">
                                    <p>
                                        Nichtteilnahme Tabelle für einen Zirkel macht keinen Sinn und sollte logischerweise immer
                                        leer sein.
                                    </p>
                                    <p>Daher wird hier nichts angezeigt.</p>
                                    <v-btn
                                        size="small"
                                        @click="navigationStore.eventId = event.id"
                                        v-if="event && event != null && event != undefined"
                                        class="mt-3"
                                    >
                                        <template v-slot:prepend>
                                            <span class="material-symbols-outlined"> search </span></template
                                        >
                                        Wechsel zum Event
                                    </v-btn>
                                </div>
                            </v-row>
                            <ModifyParticipantsList
                                type="signedoff"
                                event-or-zirkel="event"
                                :id="logicalEventId"
                                :event-id="logicalEventId"
                                v-if="
                                    event &&
                                    event != null &&
                                    event != undefined &&
                                    !(zirkel && zirkel != null && zirkel != undefined)
                                "
                                :event-type="event.type"
                            ></ModifyParticipantsList>
                        </v-window-item>
                    </v-window>
                </v-card-text>
            </template>
        </v-card>
    </div>
</template>
